<?php
/***************************************************************
*  Copyright notice
*  
*  (c) 1999-2003 Kasper Skrhj (kasper@typo3.com)
*  All rights reserved
*
*  This script is part of the Typo3 project. The Typo3 project is 
*  free software; you can redistribute it and/or modify
*  it under the terms of the GNU General Public License as published by
*  the Free Software Foundation; either version 2 of the License, or
*  (at your option) any later version.
* 
*  The GNU General Public License can be found at
*  http://www.gnu.org/copyleft/gpl.html.
*  A copy is found in the textfile GPL.txt and important notices to the license 
*  from the author is found in LICENSE.txt distributed with these scripts.
*
* 
*  This script is distributed in the hope that it will be useful,
*  but WITHOUT ANY WARRANTY; without even the implied warranty of
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*  GNU General Public License for more details.
*
*  This copyright notice MUST APPEAR in all copies of the script!
***************************************************************/
/**
 * @author	Kasper Skrhj <kasper@typo3.com>
 */

require_once (PATH_t3lib."class.t3lib_xml.php");

class user_wapversion {
	var $cObj;		// The backReference to the mother cObj object set at call time

	var $idx=0;

	/**
	 * Main function.
	 */
	function main_wapversion($content,$conf)	{
		$GLOBALS["TSFE"]->set_no_cache();


		$className=t3lib_div::makeInstanceClassName("t3lib_xml");
		$xmlObj = new $className("wml");
		$xmlObj->XMLdebug=$conf["debug"];

			// Creating top level object
		$xmlObj->WAPHeader();

			// Creating back button:
		$xmlObj->WAPback();
		
		$pageRec = $GLOBALS["TSFE"]->page;
		if ($GLOBALS["TSFE"]->idParts[1])	{
				// Creating content card:
			$xmlObj->newLevel("card",1,array(
				"id" => "content", 
				"title" => ($conf["preTitle"]?$conf["preTitle"].": ":"").$pageRec["title"]
			));
			
			$cParts = $this->contentAll();
			$pointer = t3lib_div::intInRange($GLOBALS["TSFE"]->idParts[1],1,10000);
//debug($cParts);
			$msg="";
			if ($pointer-1)	{$msg.=$this->navLink(htmlspecialchars($conf["navLabels."]["prev"]),$pointer-1)." ";}
			$msg.=$this->navLink(htmlspecialchars($conf["navLabels."]["up"]),0)." ";
			if ($pointer<count($cParts))	{$msg.=$this->navLink(htmlspecialchars($conf["navLabels."]["next"]),$pointer+1)." ";}
			$msg.= "[".$pointer."/".count($cParts)."]<br/>";
			
			$xmlObj->lines[] = $this->paragraph($msg);
			$xmlObj->lines[] = $this->paragraph($cParts[$pointer-1]);
			$xmlObj->lines[] = $this->paragraph("<br/>".$msg);
			
			$xmlObj->newLevel("card",0);
		} else {
				// Creating menu card:
			$xmlObj->newLevel("card",1,array(
				"id" => "menu", 
				"title" => ($conf["preTitle"]?$conf["preTitle"].": ":"").$pageRec["title"]
			));
			$xmlObj->lines[] = $this->contentAbstract();
			$xmlObj->lines[] = '<p><br/>'.$this->bold("Menu:").'</p>';
			$xmlObj->lines[] = $this->menuCurrentLevel($xmlObj->Icode);
			$xmlObj->newLevel("card",0);
		}

			// Footer
		$xmlObj->renderFooter();
		return $xmlObj->getResult();

	}
	function contentAbstract()	{
		$res = $this->getContentResult("tt_content");
		$row = mysql_fetch_assoc($res);
		$out = $this->bold(t3lib_div::fixed_lgd(htmlspecialchars($row["header"]),20))."<br/>";
		$out.= t3lib_div::fixed_lgd(htmlspecialchars($row["bodytext"]),50);
		$out = '<p>'.$out.' <a href="?id='.$GLOBALS["TSFE"]->id.',1.'.$GLOBALS["TSFE"]->type.'">[more]</a></p>';
		return $out;
	}
	function contentAll($chunkLgd=850)	{
		$res = $this->getContentResult("tt_content");
		$overlap=5;
		$idx=0;
		$out=array();
		while($row = mysql_fetch_assoc($res))	{
				// Header:
			$get = "<br/>".$this->cHeader($row["header"])."<br/>";
			if (strlen($out[$idx].$get)>$chunkLgd)	{
				$idx++;
			}
			$out[$idx].=$get;

			switch($row["CType"])	{
				case "text":
				case "bullets":
				case "table":
					$bodyText = $row["bodytext"];
				break;
				case "textpic":
				case "image":
					if ($row["CType"]!="image")		{$bodyText = $row["bodytext"];}
					$bodyText.= chr(10)."[".count(explode(",",$row["image"]))."images, caption: ".$row["imagecaption"]."]";
				break;
				case "header":
					$bodyText=$row["subheader"];
				break;
				default:
					$bodyText = "[Un-rendered element, ".$row["CType"]."]";
				break;
			}	
			
				// Bodytext:
			$get = $this->cBodytext($bodyText)."<br/>";
			$diff = $chunkLgd - strlen($out[$idx]);
//			debug($diff);
			if ($diff>strlen($get))	{
				$out[$idx].=$get;
			} else {
				$out[$idx].=$this->cBodytext($bodyText,0,$diff+$overlap)."<br/>";
					
				$safe=0;
				do {
					$idx++;
					$out[$idx].=$this->cBodytext($bodyText,$diff+($safe*$chunkLgd)-$overlap,$chunkLgd+$overlap)."<br/>";
					$safe++;
					if ($safe>100) break;
				} while (strlen($out[$idx])>$chunkLgd);
			}
		}
		return $out;
	}
	function cHeader($str)	{
		$out = $this->bold(htmlspecialchars(strip_tags($str)));
		return $out;
	}
	function cBodytext($str,$start=0,$max=0)	{
		$out = t3lib_div::fixed_lgd(($start?"...":"").substr($this->nl2br(htmlspecialchars(strip_tags($str))),$start),($max?$max:100000));
		$out = str_replace("&","",$out);	// No & in WAP docs???
		return $out;
	}
	function nl2br($str)	{
		return ereg_replace(chr(10),"<br/>",$str);
	}
	function getContentResult($table) {
		global $TCA;
		if ($TCA[$table])	{
			$orderBy = ($TCA[$table]["ctrl"]["sortby"]) ? "ORDER BY ".$TCA[$table]["ctrl"]["sortby"] : $TCA[$table]["ctrl"]["default_sortby"];
			$query = "SELECT * FROM ".$table." WHERE pid=".$GLOBALS["TSFE"]->id.$this->cObj->enableFields($table)." ".$orderBy;
			$res = mysql(TYPO3_db,$query);
			return $res;
		}
	}
	function bold($str)	{
		return strtoupper($str);	
	}
	function paragraph($str)	{
		return '<p>'.$str.'</p>';
	}
	function line($str)	{
		return $str.'<br/>';
	}
	function link($str,$id,$deck="")	{
		if ($GLOBALS["TSFE"]->id==$id && $deck)	{
			$out = '<a href="#'.$deck.'">'.$str.'</a>';
		} else {
			$type = $GLOBALS["TSFE"]->type;
			$out = '<a href="?id='.$id.",".($GLOBALS["TSFE"]->id==$id?1:$this->idx).'.'.$type.'">'.$str.'</a>';
		}
		return $out;
	}
	function navLink($str,$pointer)	{
		return '<a href="?id='.$GLOBALS["TSFE"]->id.','.$pointer.'.'.$GLOBALS["TSFE"]->type.'">'.$str.'</a>';
	}
	function menuCurrentLevel($indent)	{
		$rL = $GLOBALS["TSFE"]->config["rootLine"];
		reset($rL);
		$preSpace="";
		$out=array();
			// Hierarchy menu
		while(list($level,$data)=each($rL))	{
			$preSign = count($rL)-1 > $level ? "-" : ">";
			$menuItem = htmlspecialchars($preSign." ".$data["title"]);
			$menuItem = $this->link($preSpace.$menuItem,$data["uid"]);
			$out[]=$indent.$this->line($menuItem);
			$preSpace.="..";
		}
			// Current page menu:
		$menu = $this->cleanMenuArray($GLOBALS["TSFE"]->sys_page->getMenu($GLOBALS["TSFE"]->id));
		reset($menu);
		while(list(,$data)=each($menu))	{
			$preSign = count($this->cleanMenuArray($GLOBALS["TSFE"]->sys_page->getMenu($data["uid"]))) ? "+" : "*";
			$menuItem = htmlspecialchars($preSign." ".$data["title"]);
			$menuItem = $this->link($preSpace.$menuItem,$data["uid"]);
			$out[]=$indent.$this->line($menuItem);
		}
		return $this->paragraph(implode(chr(10),$out));
	}
	function cleanMenuArray($menu)	{
		reset($menu);
		$newMenu=array();
		while(list(,$data)=each($menu))	{
			if ($data["doktype"]!=5)	{
				$newMenu[]=$data;
			}
		}
		return $newMenu;	
	}
}




		/*
switch($id)	{
	case 1:
		<wml>
			<card id="Hallo" ontimer="#Login" title="wapportal.dk">
				<timer value="35"/>
				<p>
					<img src="/images/logo.wbmp" alt="WAPPORTAL"/>
					asf asdf asdf 
				</p>
			</card>
			<card id="Login" title="wapportal.dk" newcontext="true">
				<p>Mobil nr:
					<input name="Login" title="Mobil nr:" value="" format="*N" size="15"/>Kodeord:
					<input name="Passwd" title="Kodeord:" value="" type="password" format="*N" size="12"/>
					<anchor>Login !<go href="/wap/portal/DeckPortal/menu.wml?sid=FGBNRru&amp;rnd=107915&amp;login=$(Login:u)&amp;pwd=$(Passwd:u)"/></anchor>
					<br/>
					<anchor>G&#xe6;st<go href="/wap/portal/DeckPortal/menu.wml?sid=FGBNRru&amp;rnd=107916&amp;login=visitor&amp;pwd=visitor"></go></anchor>
				</p>
			</card>
		</wml>
	break;
	default:
		<wml>
		<template>
			<do type="accept" label="Back"><prev/></do>
		</template>
		<card id="index1" title="Hovedside">
			<p>Hej Kasper.
			Dette er noget
			<img src="/images/logo.wbmp" alt="WAPPORTAL"/>
			 tekst.</p>
			 
		</card>
		</wml>
	break;
}
*/




if (defined("TYPO3_MODE") && $TYPO3_CONF_VARS[TYPO3_MODE]["XCLASS"]["media/scripts/wapversionLib.inc"])	{
	include_once($TYPO3_CONF_VARS[TYPO3_MODE]["XCLASS"]["media/scripts/wapversionLib.inc"]);
}


?>