<?php
// ******************************************************************
// This is the standard TypoScript links table, tt_links
// ******************************************************************
$TCA["tt_links"] = Array (
	"ctrl" => $TCA["tt_links"]["ctrl"],
	"interface" => Array (
		"showRecordFieldList" => "title,url,hidden,note,category,starttime,endtime,image"
	),
	"columns" => Array (	
		"starttime" => Array (
			"label" => "LLL:EXT:lang/locallang_general.php:LGL.starttime",
			"config" => Array (
				"type" => "input",
				"size" => "8",
				"max" => "20",
				"eval" => "date",
				"checkbox" => "0",
				"default" => "0"
			)
		),
		"endtime" => Array (
			"label" => "LLL:EXT:lang/locallang_general.php:LGL.endtime",
			"config" => Array (
				"type" => "input",
				"size" => "8",
				"max" => "20",
				"eval" => "date",
				"checkbox" => "0",
				"default" => "0",
				"range" => Array (
					"upper" => mktime(0,0,0,12,31,2020),
					"lower" => mktime(0,0,0,date("m")-1,date("d"),date("Y"))
				)
			)
		),
		"title" => Array (
			"label" => "LLL:EXT:lang/locallang_general.php:LGL.title",
			"config" => Array (
				"type" => "input",
				"size" => "40",
				"max" => "256"
			)
		),
		"note" => Array (
			"label" => "LLL:EXT:lang/locallang_general.php:LGL.note",
			"config" => Array (
				"type" => "text",
				"cols" => "40",	
				"rows" => "5"
			)
		),

		"url" => Array (
			"label" => "LLL:EXT:tt_links/locallang_tca.php:tt_links.url",
			"config" => Array (
				"type" => "input",
				"size" => "40",
				"eval" => "trim",
				"max" => "256"
			)
		),

		"category" => Array (
			"label" => "LLL:EXT:lang/locallang_general.php:LGL.category",
			"config" => Array (
				"type" => "select",
				"items" => Array (
					Array("", 0)
				),
				"foreign_table" => "tt_links_cat"
			)
		),

		"image" => Array (
			"label" => "LLL:EXT:lang/locallang_general.php:LGL.images",
			"config" => Array (
				"type" => "group",
				"internal_type" => "file",
				"allowed" => $GLOBALS["TYPO3_CONF_VARS"]["GFX"]["imagefile_ext"],
				"max_size" => "1000",
				"uploadfolder" => "uploads/pics",
				"show_thumbs" => "1",
				"size" => "3",
				"maxitems" => "6",
				"minitems" => "0"
			)
		),
		"hidden" => Array (
			"exclude" => 1,	
			"label" => "LLL:EXT:lang/locallang_general.php:LGL.hidden",
			"config" => Array (
				"type" => "check",
				"default" => "1"
			)
		)
	),
	"types" => Array (	
		"1" => Array("showitem" => "hidden;;;;1-1-1, title;;;;3-3-3, note, url, category;;4, image")
	),
	"palettes" => Array (
		"0" => Array("showitem" => "starttime, endtime"),
	)
);


$TCA["tt_links_cat"] = Array (
	"ctrl" => $TCA["tt_links_cat"]["ctrl"],
	"interface" => Array (
		"showRecordFieldList" => "title"
	),
	"columns" => Array (	
		"title" => Array (
			"label" => "LLL:EXT:lang/locallang_general.php:LGL.title",
			"config" => Array (
				"type" => "input",
				"size" => "40",
				"max" => "256"
			)
		)
	),
	"types" => Array (	
		"0" => Array("showitem" => "title;;;;3-3-3")
	)
);


?>